Re: [PATCH v3 02/20] t/perf: add performance test for sparse operations

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On 3/17/2021 4:41 AM, Ævar Arnfjörð Bjarmason wrote:
> 
> On Tue, Mar 16 2021, Derrick Stolee via GitGitGadget wrote:
>> +test_expect_success 'setup repo and indexes' '
>> +	git reset --hard HEAD &&
>> +	# Remove submodules from the example repo, because our
>> +	# duplication of the entire repo creates an unlikly data shape.
>> +	git config --file .gitmodules --get-regexp "submodule.*.path" >modules &&
>> +	git rm -f .gitmodules &&
>> +	for module in $(awk "{print \$2}" modules)
>> +	do
>> +		git rm $module || return 1
>> +	done &&
>> +	git commit -m "remove submodules" &&
> 
> Paradoxically with this you can no longer use a repo that's not git.git
> or another repo that has submodules, since we'll die in trying to remove
> them.

Good point.

> Also you don't have to "git rm .gitmodules", the "git rm" command
> removes submodule entries.

Sure.

> Perhaps just:
> 
>     for module in $(git ls-files --stage | grep ^160000 | awk -F '\t' '{ print $2 }')
>     do
>         git rm "$module"
>     done
> 
> Or another way of guarding against rm getting the empty list && commit?
> 
> But it seems odd to be doing this at all, the point of the perf
> framework is that you can point it at any repo, and some repos you want
> to test will have submodules.

You're right that it should handle all repos. However, the point of
the test is to have many copies of the repo, but most of them are
excluded by sparse-directory entries. We don't collapse sparse-directory
entries if there is a submodule inside, so the data shape is wrong after
making all the copies.

So, I disagree with your approach in your suggested diff, and instead
offer this one. I've tested this with git.git and another local repo
without submodules and checked that everything works as expected.

diff --git a/t/perf/p2000-sparse-operations.sh b/t/perf/p2000-sparse-operations.sh
index e527316e66d..5c0d78eeeea 100755
--- a/t/perf/p2000-sparse-operations.sh
+++ b/t/perf/p2000-sparse-operations.sh
@@ -10,15 +10,17 @@ SPARSE_CONE=f2/f4/f1
 
 test_expect_success 'setup repo and indexes' '
 	git reset --hard HEAD &&
+
 	# Remove submodules from the example repo, because our
-	# duplication of the entire repo creates an unlikly data shape.
-	git config --file .gitmodules --get-regexp "submodule.*.path" >modules &&
-	git rm -f .gitmodules &&
-	for module in $(awk "{print \$2}" modules)
-	do
-		git rm $module || return 1
-	done &&
-	git commit -m "remove submodules" &&
+	# duplication of the entire repo creates an unlikely data shape.
+	if (git config --file .gitmodules --get-regexp "submodule.*.path" >modules)
+	then
+		for module in $(awk "{print \$2}" modules)
+		do
+			git rm $module || return 1
+		done &&
+		git commit -m "remove submodules" || return 1
+	fi &&
 
 	echo bogus >a &&
 	cp a b &&

> Seems like something like the WIP patch at the end on top would be
> better.
> 
>> +	echo bogus >a &&
>> +	cp a b &&
>> +	git add a b &&
>> +	git commit -m "level 0" &&
>> +	BLOB=$(git rev-parse HEAD:a) &&
> 
> Isn't the way we're getting this $BLOB equivalent to just 'echo bogus |
> git hash-object --stdin -w' why commit it?

We are committing it so we can add commits that deepen the copies,
but within those copies we have these known file paths.

> This whole thing makes me think you just wanted a test_perf_fresh_repo
> all along, but I think this would be much more useful if you took the
> default repo and multiplied the size in its tree by some multiple.
> 
> E.g. take the files we have in git.git, write a copy at prefix-1/,
> prefix-2/ etc.

That is essentially what is happening here, but using multiple levels
of directories. Using these multiple levels presents extra tree
lookups and parsing in the event of expanding a sparse index to a
full one.

Thanks,
-Stolee



[Index of Archives]     [Linux Kernel Development]     [Gcc Help]     [IETF Annouce]     [DCCP]     [Netdev]     [Networking]     [Security]     [V4L]     [Bugtraq]     [Yosemite]     [MIPS Linux]     [ARM Linux]     [Linux Security]     [Linux RAID]     [Linux SCSI]     [Fedora Users]

  Powered by Linux